glibmm: Glib::MatchInfo Class Reference

glibmm 2.89.0

Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
Glib::MatchInfo Class Reference

MatchInfo - MatchInfo is used to retrieve information about the regular expression match which created it. More...

`#include <glibmm/regex.h>`

## Public Member Functions
| MatchInfo ()
| Default constructor.
| MatchInfo (GMatchInfo * castitem, bool take_ownership=true)
| C object constructor.
| MatchInfo (const MatchInfo & other)=delete
MatchInfo & | operator= (const MatchInfo & other)=delete
| MatchInfo (MatchInfo && other) noexcept
MatchInfo & | operator= (MatchInfo && other) noexcept
virtual | ~MatchInfo ()
| Destructor.
GMatchInfo * | gobj ()
| Provides access to the underlying C object.
const GMatchInfo * | gobj () const
| Provides access to the underlying C object.
Glib::RefPtr< Regex > | get_regex ()
| Returns Regex object used in match_info.
Glib::RefPtr< const Regex > | get_regex () const
| Returns Regex object used in match_info.
Glib::ustring | get_string () const
| Returns the string searched with match_info.
bool | matches () const
| Returns whether the previous match operation succeeded.
bool | next ()
| Scans for the next match using the same parameters of the previous call to g_regex_match_full() or g_regex_match() that returned match_info.
int | get_match_count () const
| Retrieves the number of matched substrings (including substring 0, that is the whole matched text), so 1 is returned if the pattern has no substrings in it and 0 is returned if the match failed.
bool | is_partial_match () const
| Usually if the string passed to g_regex_match*() matches as far as it goes, but is too short to match the entire pattern, false is returned.
Glib::ustring | expand_references (Glib::UStringView string_to_expand)
| Returns a new string containing the text in string_to_expand with references and escape sequences expanded.
Glib::ustring | fetch (int match_num)
| Retrieves the text matching the match_num'th capturing parentheses.
bool | fetch_pos (int match_num, int & start_pos, int & end_pos)
| Returns the start and end positions (in bytes) of a successfully matching capture parenthesis.
Glib::ustring | fetch_named (Glib::UStringView name)
| Retrieves the text matching the capturing parentheses named name.
bool | fetch_named_pos (Glib::UStringView name, int & start_pos, int & end_pos)
| Retrieves the position in bytes of the capturing parentheses named name.
std::vector< Glib::ustring > | fetch_all ()
| Bundles up pointers to each of the matching substrings from a match and stores them in an array of gchar pointers.

## Protected Member Functions
void | set_gobject (GMatchInfo * castitem, bool take_ownership=true)

## Protected Attributes
GMatchInfo * | gobject_
bool | take_ownership_

## Detailed Description

MatchInfo - MatchInfo is used to retrieve information about the regular expression match which created it.

Since glibmm 2.28

## Constructor & Destructor Documentation

## ◆ MatchInfo() [1/4]

Glib::MatchInfo::MatchInfo | ( |  | ) |

Default constructor.

## ◆ MatchInfo() [2/4]

Glib::MatchInfo::MatchInfo | ( | GMatchInfo * | castitem,
|  | bool | take_ownership = true )
| explicit

C object constructor.

Parameters

  castitem | The C object.
  take_ownership | Whether to destroy the C object with the wrapper or not.

## ◆ MatchInfo() [3/4]

Glib::MatchInfo::MatchInfo | ( | const MatchInfo & | other | ) |
| delete

## ◆ MatchInfo() [4/4]

Glib::MatchInfo::MatchInfo | ( | MatchInfo && | other | ) |
| noexcept

## ◆ ~MatchInfo()

virtual Glib::MatchInfo::~MatchInfo | ( |  | ) |
| virtual

Destructor.

## Member Function Documentation

## ◆ expand_references()

Glib::ustring Glib::MatchInfo::expand_references | ( | Glib::UStringView | string_to_expand | ) |

Returns a new string containing the text in string_to_expand with references and escape sequences expanded.

References refer to the last match done with string against regex and have the same syntax used by g_regex_replace().

The string_to_expand must be UTF-8 encoded even if Glib::Regex::CompileFlags::RAW was passed to g_regex_new().

The backreferences are extracted from the string passed to the match function, so you cannot call this function after freeing the string.

match_info may be nullptr in which case string_to_expand must not contain references. For instance "foo\\n" does not refer to an actual pattern and '\n' merely will be replaced with \n character, while to expand "\\0" (whole match) one needs the result of a match. Use g_regex_check_replacement() to find out whether string_to_expand contains references.

Since glibmm 2.14

Parameters

  string_to_expand | The string to expand.

Returns
  The expanded string, or nullptr if an error occurred.

Exceptions

  Glib::RegexError |

## ◆ fetch()

Glib::ustring Glib::MatchInfo::fetch | ( | int | match_num | ) |

Retrieves the text matching the match_num'th capturing parentheses.

0 is the full text of the match, 1 is the first paren set, 2 the second, and so on.

If match_num is a valid sub pattern but it didn't match anything (e.g. sub pattern 1, matching "b" against "(a)?b") then an empty string is returned. When a partial match is reported via g_match_info_is_partial_match() only the full text of the match can be queried ( match_num must be 0).

If the match was obtained using the DFA algorithm, that is using g_regex_match_all() or g_regex_match_all_full(), the retrieved string is not that of a set of parentheses but that of a matched substring. Substrings are matched in reverse order of length, so 0 is the longest match.

The string is fetched from the string passed to the match function, so you cannot call this function after freeing the string.

Since glibmm 2.14

Parameters

  match_num | Number of the sub expression.

Returns
  The matched substring, or nullptr if an error occurred. You have to free the string yourself.

## ◆ fetch_all()

std::vector< Glib::ustring > Glib::MatchInfo::fetch_all | ( |  | ) |

Bundles up pointers to each of the matching substrings from a match and stores them in an array of gchar pointers.

The first element in the returned array is the match number 0, i.e. the entire matched text.

If a sub pattern didn't match anything (e.g. sub pattern 1, matching "b" against "(a)?b") then an empty string is inserted.

When a partial match is reported via g_match_info_is_partial_match() only the full text of the match will be returned, i.e. an array of size 1.

If the last match was obtained using the DFA algorithm, that is using g_regex_match_all() or g_regex_match_all_full(), the retrieved strings are not that matched by sets of parentheses but that of the matched substring. Substrings are matched in reverse order of length, so the first one is the longest match.

The strings are fetched from the string passed to the match function, so you cannot call this function after freeing the string.

Since glibmm 2.14

Returns
  A nullptr-terminated array of gchar * pointers. If the previous match failed nullptr is returned.

## ◆ fetch_named()

Glib::ustring Glib::MatchInfo::fetch_named | ( | Glib::UStringView | name | ) |

Retrieves the text matching the capturing parentheses named name.

If name is a valid sub pattern name but it didn't match anything (e.g. sub pattern "X", matching "b" against "(?P<X>a)?b") then an empty string is returned.

The string is fetched from the string passed to the match function, so you cannot call this function after freeing the string.

Since glibmm 2.14

Parameters

  name | Name of the subexpression.

Returns
  The matched substring, or nullptr if an error occurred. You have to free the string yourself.

## ◆ fetch_named_pos()

bool Glib::MatchInfo::fetch_named_pos | ( | Glib::UStringView | name,
|  | int & | start_pos,
|  | int & | end_pos )

Retrieves the position in bytes of the capturing parentheses named name.

If name is a valid sub pattern name but it didn't match anything (e.g. sub pattern "X", matching "b" against "(?P<X>a)?b") then start_pos and end_pos are set to -1 and true is returned.

As end_pos is set to the byte after the final byte of the match (on success), the length of the match can be calculated as end_pos - start_pos.

Since glibmm 2.14

Parameters

  name | Name of the subexpression.
  start_pos | Pointer to location where to store the start position, or nullptr.
  end_pos | Pointer to location where to store the end position (the byte after the final byte of the match), or nullptr.

Returns
  true if the position was fetched, false otherwise. If the position cannot be fetched, start_pos and end_pos are left unchanged.

## ◆ fetch_pos()

bool Glib::MatchInfo::fetch_pos | ( | int | match_num,
|  | int & | start_pos,
|  | int & | end_pos )

Returns the start and end positions (in bytes) of a successfully matching capture parenthesis.

Valid values for match_num are 0 for the full text of the match, 1 for the first paren set, 2 for the second, and so on. When a partial match is reported via g_match_info_is_partial_match() only the full text of the match can be queried ( match_num must be 0).

As end_pos is set to the byte after the final byte of the match (on success), the length of the match can be calculated as end_pos - start_pos.

As a best practice, initialize start_pos and end_pos to identifiable values, such as G_MAXINT, so that you can test if g_match_info_fetch_pos() actually changed the value for a given capture parenthesis.

The parameter match_num corresponds to a matched capture parenthesis. The actual value you use for match_num depends on the method used to generate match_info. The following sections describe those methods.

## Methods Using Non-deterministic Finite Automata Matching

The methods Glib::Regex::match() and Glib::Regex::match_full() return a Glib::MatchInfo using traditional (greedy) pattern matching, also known as Non-deterministic Finite Automaton (NFA) matching. You pass the returned MatchInfo from these methods to g_match_info_fetch_pos() to determine the start and end positions of capture parentheses. The values for match_num correspond to the capture parentheses in order, with 0 corresponding to the entire matched string.

match_num can refer to a capture parenthesis with no match. For example, the string b matches against the pattern (a)?b, but the capture parenthesis (a) has no match. In this case, g_match_info_fetch_pos() returns true and sets start_pos and end_pos to -1 when called with match_num as 1 (for (a)).

For an expanded example, a regex pattern is (a)?(.*?)the (.*), and a candidate string is glib regexes are the best. In this scenario there are four capture parentheses numbered 0–3: an implicit one for the entire string, and three explicitly declared in the regex pattern.

Given this example, the following table describes the return values from g_match_info_fetch_pos() for various values of match_num.

match_num | Contents | Return value | Returned start_pos | Returned end_pos
--- | --- | --- | --- | ---
0 | Matches entire string | True | 0 | 25
1 | Does not match first character | True | -1 | -1
2 | All text before the | True | 0 | 17
3 | All text after the | True | 21 | 25
4 | Capture paren out of range | False | Unchanged | Unchanged

The following code sample and output implements this example.

{ .c }
#include <glib.h>
int
main (int argc, char *argv[])
{
g_autoptr(GError) local_error = <tt>nullptr</tt>;
const char *regex_pattern = "(a)?(.*?)the (.*)";
const char *test_string = "glib regexes are the best";
g_autoptr(GRegex) regex = <tt>nullptr</tt>;
regex = g_regex_new (regex_pattern,
G_REGEX_DEFAULT,
G_REGEX_MATCH_DEFAULT,
&local_error);
if (regex == <tt>nullptr</tt>)
{
g_printerr ("Error creating regex: %s\\n", local_error->message);
return 1;
}
g_autoptr(GMatchInfo) match_info = <tt>nullptr</tt>;
g_regex_match (regex, test_string, G_REGEX_MATCH_DEFAULT, &match_info);
int n_matched_strings = g_match_info_get_match_count (match_info);
// Print header line
g_print ("match_num Contents Return value returned start_pos returned end_pos\\n");
// Iterate over each capture paren, including one that is out of range as a demonstration.
for (int match_num = 0; match_num <= n_matched_strings; match_num++)
{
<tt>bool</tt> found_match;
g_autofree char *paren_string = <tt>nullptr</tt>;
int start_pos = G_MAXINT;
int end_pos = G_MAXINT;
found_match = g_match_info_fetch_pos (match_info,
match_num,
&start_pos,
&end_pos);
// If no match, display N/A as the found string.
if (start_pos == G_MAXINT || start_pos == -1)
paren_string = g_strdup ("N/A");
else
paren_string = g_strndup (test_string + start_pos, end_pos - start_pos);
g_print ("%-9d %-25s %-12d %-18d %d\\n", match_num, paren_string, found_match, start_pos, end_pos);
}
return 0;
}
regex
basic_regex< char > regex
match_num Contents Return value returned start_pos returned end_pos
0 glib regexes are the best 1 0 25
1 N/A 1 -1 -1
2 glib regexes are 1 0 17
3 best 1 21 25
4 N/A 0 2147483647 2147483647

## Methods Using Deterministic Finite Automata Matching

The methods Glib::Regex::match_all() and Glib::Regex::match_all_full() return a MatchInfo using Deterministic Finite Automaton (DFA) pattern matching. This algorithm detects overlapping matches. You pass the returned MatchInfo from these methods to g_match_info_fetch_pos() to determine the start and end positions of each overlapping match. Use the method Glib::MatchInfo::get_match_count() to determine the number of overlapping matches.

For example, a regex pattern is <.*>, and a candidate string is <a> <b> <c>. In this scenario there are three implicit capture parentheses: one for the entire string, one for <a> <b>, and one for <a>.

Given this example, the following table describes the return values from g_match_info_fetch_pos() for various values of match_num.

match_num | Contents | Return value | Returned start_pos | Returned end_pos
--- | --- | --- | --- | ---
0 | Matches entire string | True | 0 | 11
1 | Matches <a> <b> | True | 0 | 7
2 | Matches <a> | True | 0 | 3
3 | Capture paren out of range | False | Unchanged | Unchanged

The following code sample and output implements this example.

{ .c }
#include <glib.h>
int
main (int argc, char *argv[])
{
g_autoptr(GError) local_error = <tt>nullptr</tt>;
const char *regex_pattern = "<.*>";
const char *test_string = "<a> <b> <c>";
g_autoptr(GRegex) regex = <tt>nullptr</tt>;
regex = g_regex_new (regex_pattern,
G_REGEX_DEFAULT,
G_REGEX_MATCH_DEFAULT,
&local_error);
if (regex == <tt>nullptr</tt>)
{
g_printerr ("Error creating regex: %s\\n", local_error->message);
return -1;
}
g_autoptr(GMatchInfo) match_info = <tt>nullptr</tt>;
g_regex_match_all (regex, test_string, G_REGEX_MATCH_DEFAULT, &match_info);
int n_matched_strings = g_match_info_get_match_count (match_info);
// Print header line
g_print ("match_num Contents Return value returned start_pos returned end_pos\\n");
// Iterate over each capture paren, including one that is out of range as a demonstration.
for (int match_num = 0; match_num <= n_matched_strings; match_num++)
{
<tt>bool</tt> found_match;
g_autofree char *paren_string = <tt>nullptr</tt>;
int start_pos = G_MAXINT;
int end_pos = G_MAXINT;
found_match = g_match_info_fetch_pos (match_info, match_num, &start_pos, &end_pos);
// If no match, display N/A as the found string.
if (start_pos == G_MAXINT || start_pos == -1)
paren_string = g_strdup ("N/A");
else
paren_string = g_strndup (test_string + start_pos, end_pos - start_pos);
g_print ("%-9d %-25s %-12d %-18d %d\\n", match_num, paren_string, found_match, start_pos, end_pos);
}
return 0;
}
match_num Contents Return value returned start_pos returned end_pos
0 <a> <b> <c> 1 0 11
1 <a> <b> 1 0 7
2 <a> 1 0 3
3 N/A 0 2147483647 2147483647

Since glibmm 2.14

Parameters

  match_num | Number of the capture parenthesis.
  start_pos | Pointer to location where to store the start position, or nullptr.
  end_pos | Pointer to location where to store the end position (the byte after the final byte of the match), or nullptr.

Returns
  True if match_num is within range, false otherwise. If the capture paren has a match, start_pos and end_pos contain the start and end positions (in bytes) of the matching substring. If the capture paren has no match, start_pos and end_pos are -1. If match_num is out of range, start_pos and end_pos are left unchanged.

## ◆ get_match_count()

int Glib::MatchInfo::get_match_count | ( |  | ) | const

Retrieves the number of matched substrings (including substring 0, that is the whole matched text), so 1 is returned if the pattern has no substrings in it and 0 is returned if the match failed.

If the last match was obtained using the DFA algorithm, that is using g_regex_match_all() or g_regex_match_all_full(), the retrieved count is not that of the number of capturing parentheses but that of the number of matched substrings.

Since glibmm 2.14

Returns
  Number of matched substrings, or -1 if an error occurred.

## ◆ get_regex() [1/2]

Glib::RefPtr< Regex > Glib::MatchInfo::get_regex | ( |  | ) |

Returns Regex object used in match_info.

It belongs to Glib and must not be freed. Use g_regex_ref() if you need to keep it after you free match_info object.

Since glibmm 2.14

Returns
  Regex object used in match_info.

## ◆ get_regex() [2/2]

Glib::RefPtr< const Regex > Glib::MatchInfo::get_regex | ( |  | ) | const

Returns Regex object used in match_info.

It belongs to Glib and must not be freed. Use g_regex_ref() if you need to keep it after you free match_info object.

Since glibmm 2.14

Returns
  Regex object used in match_info.

## ◆ get_string()

Glib::ustring Glib::MatchInfo::get_string | ( |  | ) | const

Returns the string searched with match_info.

This is the string passed to g_regex_match() or g_regex_replace() so you may not free it before calling this function.

Since glibmm 2.14

Returns
  The string searched with match_info.

## ◆ gobj() [1/2]

GMatchInfo * Glib::MatchInfo::gobj | ( |  | ) |
| inline

Provides access to the underlying C object.

## ◆ gobj() [2/2]

const GMatchInfo * Glib::MatchInfo::gobj | ( |  | ) | const
| inline

Provides access to the underlying C object.

## ◆ is_partial_match()

bool Glib::MatchInfo::is_partial_match | ( |  | ) | const

Usually if the string passed to g_regex_match*() matches as far as it goes, but is too short to match the entire pattern, false is returned.

There are circumstances where it might be helpful to distinguish this case from other cases in which there is no match.

Consider, for example, an application where a human is required to type in data for a field with specific formatting requirements. An example might be a date in the form ddmmmyy, defined by the pattern "^\\d?\\d(jan|feb|mar|apr|may|jun|jul|aug|sep|oct|nov|dec)\\d\\d$". If the application sees the user’s keystrokes one by one, and can check that what has been typed so far is potentially valid, it is able to raise an error as soon as a mistake is made.

GRegex supports the concept of partial matching by means of the Glib::Regex::MatchFlags::PARTIAL_SOFT and Glib::Regex::MatchFlags::PARTIAL_HARD flags. When they are used, the return code for g_regex_match() or g_regex_match_full() is, as usual, true for a complete match, false otherwise. But, when these functions return false, you can check if the match was partial calling g_match_info_is_partial_match().

The difference between Glib::Regex::MatchFlags::PARTIAL_SOFT and Glib::Regex::MatchFlags::PARTIAL_HARD is that when a partial match is encountered with Glib::Regex::MatchFlags::PARTIAL_SOFT, matching continues to search for a possible complete match, while with Glib::Regex::MatchFlags::PARTIAL_HARD matching stops at the partial match. When both Glib::Regex::MatchFlags::PARTIAL_SOFT and Glib::Regex::MatchFlags::PARTIAL_HARD are set, the latter takes precedence.

There were formerly some restrictions on the pattern for partial matching. The restrictions no longer apply.

If the match was partial g_match_info_fetch(), g_match_info_fetch_pos() and g_match_info_fetch_all() can be called to retrieve the text and positions of the entire match, i.e. only for sub expression 0.

See pcrepartial(3) for more information on partial matching.

Since glibmm 2.14

Returns
  true if the match was partial, false otherwise.

## ◆ matches()

bool Glib::MatchInfo::matches | ( |  | ) | const

Returns whether the previous match operation succeeded.

Since glibmm 2.14

Returns
  true if the previous match operation succeeded, false otherwise.

## ◆ next()

bool Glib::MatchInfo::next | ( |  | ) |

Scans for the next match using the same parameters of the previous call to g_regex_match_full() or g_regex_match() that returned match_info.

The match is done on the string passed to the match function, so you cannot free it before calling this function.

Since glibmm 2.14

Returns
  true is the string matched, false otherwise.

Exceptions

  Glib::RegexError |

## ◆ operator=() [1/2]

MatchInfo & Glib::MatchInfo::operator= | ( | const MatchInfo & | other | ) |
| delete

## ◆ operator=() [2/2]

MatchInfo & Glib::MatchInfo::operator= | ( | MatchInfo && | other | ) |
| noexcept

## ◆ set_gobject()

void Glib::MatchInfo::set_gobject | ( | GMatchInfo * | castitem,
|  | bool | take_ownership = true )
| protected

## Member Data Documentation

## ◆ gobject_

GMatchInfo* Glib::MatchInfo::gobject_
| protected

## ◆ take_ownership_

bool Glib::MatchInfo::take_ownership_
| protected